#ifndef _EYLOG_DLL_H_
#define _EYLOG_DLL_H_
#pragma once //build one time


#define EYLOG_DLLIMPORT __declspec(dllexport)

/********************************************************************************************************
*
*  Definitions	궨صֵغ
*
*********************************************************************************************************/


#define SUCCESS 1
#define FAILED	0

// BWC Info
typedef struct 
{
	char cSerial[8];   /* Serial No	(Example: "1234567"	)		ִ¼ǲƷţΪ*/
	char userNo[7];    /* User Id	(Example: "123456")			ִ¼ʹ߾ţΪ*/
	char userName[33]; /* User Name (Example: "HERO1234")		ִ¼ʹϵͳʹþŹʱΪ*/
	char unitNo[13];   /* Unit Id	(Example: "123456")			ִ¼ʹߵλţϵͳʹþŹʱΪ*/
	char unitName[33]; /* Unit Name	(Example: "WEST STATION")	ִ¼ʹߵλƣϵͳʹþŹʱΪ*/
}ZFY_INFO;			

// network connect info
typedef struct
{
	char wifi_mode;  
	char wifi_name[17];   
	char wifi_psw[17]; 
	char apn_4g[33]; 
	char pin_4g[9];
	char server_ip[17];
	char server_port[9];
}ZFY_NET_INFO;

// Items For BWC Settup Menu
typedef struct
{
	char video_res;
	char video_quality;  	// Menu:9
	/*
	0: Video Quality: Super Fine
	1: Video Quality: Fine
	2: Video Quality: Normal
	*/
 	char video_format;  	// Menu:31
 	/*
 	0: Video Coding Format: H.264
 	1: Video Coding Format: H.265
 	*/
	char split_time;  	// Menu:14
	/*
	0: Video Split Time: 1 Min
	1: Video Split Time: 3 Min
	2: Video Split Time: 5 MIn
	3: Video Split Time: 10 MIn
	4: Video Split Time: 15 Min
	5: Video Split Time: 30 Min
	6: Video Split Time: 45 Min
	*/
	char loop_record;  	// Menu:13
	/*
	0: Video Loop Recording: Off
	1: Video Loop Recording: On
	*/
	char pre_record;  	// Menu:10
	/*
	0: Video Pre-recording: Off
	1: Video Pre-recording: On
	*/
 	char ir_mode; 		// Menu:16
 	/*
 	0: IR Mode: Manual
 	1: IR Mode: Auto
 	*/
	char time_zone; 	// Menu:22
	/*
	0: Time Zone: -12
	1: Time Zone: -11
	......
	23: Time Zone: +11
	24: Time Zone: +12
	*/
	char volume;  		// Menu:30
	/*
	0: Volume: 0
	1: Volume: 3
	2: Volume: 6
	3: Volume: 9
	4: Volume: 12
	*/
	char gps;  		// Menu:20
	/*
	0: GPS: Off
	1: GPS: On
	*/
	char rec_warning; 	// Menu:18
	/*
	0: Recording Warning: Off
	1: Recording Warning: On
	*/
	char photo_size;      	// Menu:5
	/*
	0: Photo Size: 5M
	1: Photo Size: 12M
	2: Photo Size: 20M
	3: Photo Size: 25M
	4: Photo Size: 30M
	5: Photo Size: 40M
	*/
	char lte;
	/*
	0: lte: Off
	1: lte: On
	*/
	char wifi;
	/*
	0: wifi: Off
	1: wifi: sta
	2: wifi: ap
	*/
	char post_record;   	// Menu:11
	/*
	0: Post Recording: Off
	1: Post Recording: 5S
	2: Post Recording: 1Min
	3: Post Recording: 10Min
	4: Post Recording: 20Min
	5: Post Recording: 35Min
	*/
	char car_dv;  		// Menu:12
	/*
	0: CarDv Mode: Off
	1: CarDv Mode: On
	*/
	
	char motion_detect;  	// Menu:17
	/*
	0: Motion Detection: Off
	1: Motion Detection: On
	*/
	
	char livestream_res;
	/*
	0: livestream_res: 1280x720P30
	1: livestream_res: 1280x720P15
	2: livestream_res: 848X480P30
	3: livestream_res: 848X480P15
	*/
	char livestream_format;
	/*
 	0: livestream_format Video Coding Format: H.264
 	1: livestream_format Video Coding Format: H.265
 	*/
	
	char gsensor;
	/*
	0: gsensor: Off
	1: gsensor: On
	*/
	char eis;
	/*
	0: eis: Off
	1: eis: On
	*/
	char res_flag[2];//for User add video resolution definition
	char photo_size_flag[2];//for User add photo size definition
	char post_rec_flag;//for User add post record definition
	char split_time_flag;//for User add split time definition
	char aes_crypto;
	/*
	0: aes_crypto: Off
	1: aes_crypto: On
	*/

}MENU_CONFIG;

// Acknowledges From BWC
typedef enum 
{
	CONNECT_SUCCESS = 0x01,	/* Connect Success			ִ¼ӳɹ*/
	CONNECT_FAILED,			/* Connect Fail				ִ¼ʧ*/
	CHECK_PWD_SUCCESS,		/* PassWord Check Success	ִ¼ǹԱУɹ*/
	CHECK_PWD_FAILED,		/* PassWord check Fail		ִ¼ǹԱУʧ*/
	SET_SYSTEMTIME_SUCCESS, /* Set SystemTime Success	ִ¼ϵͳʱͬɹ*/
	SET_SYSTEMTIME_FAILED,  /* Set SystemTime Faile		ִ¼ϵͳʱͬʧ*/
	MSDC_SUCCESS,			/* Enter MSC Success		ִ¼תƶģʽɹ*/
	MSDC_FAILED,			/* Enter MSC Fail			ִ¼תƶģʽʧ*/
};

#ifdef __cplusplus
extern "C"
{
#endif


	/*API*/
	
	
 /**
 *  @brief format tf card
 *
 *  @param [in] password
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */
	EYLOG_DLLIMPORT int	Eylog_FormatTFCard(char *sPwd, int *iRet);
	
	/**
 *  @brief set BWC net information
 *
 *  @param [in] BWC net information
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */
	EYLOG_DLLIMPORT int	Eylog_SetNetConfig(ZFY_NET_INFO *NetConf, int *iRet);
	
	/**
 *  @brief get BWC net information
 *
 *  @param [out] BWC net information
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */	
	EYLOG_DLLIMPORT int	Eylog_GetNetConfig(ZFY_NET_INFO *NetConf, int *iRet);
	
	/**
 *  @brief login bwc
 *
 *  @param [out] the password to login bwc
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int	Eylog_Login(int user_type,char *sPwd, int *iRet);


	/**
 *  @brief get tf card capacity
 *
 *  @param [out] capacity strings
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int	Eylog_GetTFVol(char *tf_vol, int *iRet);
	
	/**
 *  @brief get firmware version 
 *
 *  @param [out] firmware version strings
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */			
	EYLOG_DLLIMPORT int	Eylog_GetFwVersion(char *fw_ver, int *iRet);
	
	
	/**
 *  @brief set menu config
 *
 *  @param [in] menu config value
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */				
	EYLOG_DLLIMPORT int	Eylog_SetMenuConfig(void *menu_conf, int config_len, int *iRet);
	
	
	/**
 *  @brief set menu config
 *
 *  @param [in] menu config value
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */					
	EYLOG_DLLIMPORT int	Eylog_GetMenuConfig(void *menu_conf, int config_len, int *iRet);
	
	
	/**
 *  @brief to sense BWC is 4G camera or not
 *
 * 
 *  @param [out]  1-> 4g or 2->not 4G
 *
 *  @return 1 success, 0 failure
 */
	EYLOG_DLLIMPORT int	Eylog_Get4GDevOrNot(int *iRet);
	
	/**
 *  @brief to set default value
 *
 *  
 *  @param [out]  not use
 *
 *  @return 1 success, 0 failure
 */	
	EYLOG_DLLIMPORT int	Eylog_SetDefault(int *iRet);
	
	/**
 *  @brief to set factory default value
 *
 *  
 *  @param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */	
	EYLOG_DLLIMPORT int	Eylog_ChangePsw(int user_type, char *new_psw, int *iRet);
	
	EYLOG_DLLIMPORT int	Eylog_GetPsw(int user_type, char *old_psw, int *iRet);

/**
 *  @brief to set facory default 
 *				1).set default value
 *				2).format tf card
 *				3).enter MSC
 *  
 *  @param [out]  CONNECT_SUCCESS or CONNECT_FAILED
 *
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int	Eylog_FactoryDefault(int *iRet);



/**
 *  @brief to init bwc usb connection
 *  
 *  @param [out] bwc id code
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED

 *	
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int		Init_Device(char *IDCode, int *iRet);
	
	
	/**
 *  @brief to disconnect bwc usb connection
 *  
 * 
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT void	UnInit_Device(int *iRet);
	


	EYLOG_DLLIMPORT int	Eylog_SN_Info(int r_w, char *sn, int *iRet);
	EYLOG_DLLIMPORT int	Eylog_ApnPsw(int r_w, char *psw, int *iRet);
	EYLOG_DLLIMPORT int	Eylog_ApnUser(int r_w, char *user, int *iRet);

 /**
 *  @brief to bwc time synchronization
 *  
 *  @param [in] password
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */	
	EYLOG_DLLIMPORT int		SyncDevTime(char *sPwd, int *iRet);
	
	
/**
 *  @brief to get bwc id code
 *  
 *  @param [out] bwc id code
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED

 *	
 *  @return 1 success, 0 failure
 */			
	EYLOG_DLLIMPORT int  GetIDCode(char *IDCode, int *iRet);
	
	
	/**
 *  @brief to get some bwc information
 *  
 *  @param [out] bwc information
  * @param [in] password
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */	
	EYLOG_DLLIMPORT int  GetZFYInfo(ZFY_INFO *info, char *sPwd, int *iRet);
	
		/**
 *  @brief to set some bwc information
 *  
 *  @param [in] bwc information
  * @param [in] password
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */	
	EYLOG_DLLIMPORT int  WriteZFYInfo(ZFY_INFO *info, char *sPwd, int *iRet);
	
	
	/**
 *  @brief to enter MSC
 *  
 * 
  * @param [in] password
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int  SetMSDC(char *sPwd, int *iRet);
	
	/**
 *  @brief to get video  Resolution
 *  
 *  @param [out] width
  *  @param [out] Height
  * @param [in] password
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int  ReadDeviceResolution(int *Width, int *Height, char *sPwd, int *iRet);
	
	
		/**
 *  @brief to get battery volume
 *  
 *  @param [out] Battery volume
  * @param [in] password
 *	@param [out] CONNECT_SUCCESS or CONNECT_FAILED
 *	
 *  @return 1 success, 0 failure
 */		
	EYLOG_DLLIMPORT int  ReadDeviceBatteryDumpEnergy(int *Battery, char *sPwd, int *iRet);
	
#ifdef __cplusplus
}
#endif

#endif